import dds
import ddsutil
import std_msgs/msg/Header_.std_msgs.msg.dds_
import struct

class Joy___TypeSupport(dds.TypeSupport):

    _typename = 'sensor_msgs::msg::dds_::Joy_'
    _keylist = ''
    _metadescriptor = '<MetaData version="1.0.0"><Module name="builtin_interfaces"><Module name="msg"><Module name="dds_"><Struct name="Time_"><Member name="sec_"><Long/></Member><Member name="nanosec_"><ULong/></Member></Struct></Module></Module></Module><Module name="std_msgs"><Module name="msg"><Module name="dds_"><Struct name="Header_"><Member name="stamp_"><Type name="::builtin_interfaces::msg::dds_::Time_"/></Member><Member name="frame_id_"><String/></Member></Struct></Module></Module></Module><Module name="sensor_msgs"><Module name="msg"><Module name="dds_"><Struct name="Joy_"><Member name="header_"><Type name="::std_msgs::msg::dds_::Header_"/></Member><Member name="axes_"><Sequence><Float/></Sequence></Member><Member name="buttons_"><Sequence><Long/></Sequence></Member></Struct></Module></Module></Module></MetaData>'

    def __init__(self):
        super(Joy___TypeSupport, self).__init__(self._typename,
              self._keylist,
              self._metadescriptor,
              struct.calcsize(Joy_()._get_packing_fmt()))

    def _serialize(self, o):
        if not isinstance(o, Joy_):
            raise TypeError('Incorrect data type')
        result = o._serialize()
        return result

    def _deserialize(self, buf):
        result = Joy_()
        data = struct.unpack(result._get_packing_fmt(), buf)
        result._deserialize(list(data))
        return result

class Joy_(ddsutil.TopicDataClass):

    @staticmethod
    def get_type_support():
        ''' Return type support information required for dds.Topic constructor '''
        return Joy___TypeSupport()

    @property
    def header_(self):
        '''
        a DDS std_msgs::msg::dds_::Header_ value
        @rtype: std_msgs/msg/Header_.std_msgs.msg.dds_.Header_
        '''
        return self._header__

    _header__checker = ddsutil._class_checker(std_msgs/msg/Header_.std_msgs.msg.dds_.Header_)
    @header_.setter
    def header_(self, value):
        self._header__checker(value)
        self._header__ = value

    @property
    def axes_(self):
        '''
        a DDS sequence<float> value
        @rtype: list
        '''
        return self._axes__

    _axes__checker = ddsutil._seq_checker(0,ddsutil._float_checker)
    @axes_.setter
    def axes_(self, value):
        self._axes__checker(value)
        self._axes__ = value

    @property
    def buttons_(self):
        '''
        a DDS sequence<long> value
        @rtype: list
        '''
        return self._buttons__

    _buttons__checker = ddsutil._seq_checker(0,ddsutil._long_checker)
    @buttons_.setter
    def buttons_(self, value):
        self._buttons__checker(value)
        self._buttons__ = value

    _member_attributes = ('header_', 'axes_', 'buttons_')

    def __init__(self, **kwargs):
        ''' Create a Joy_ instance, optionally initializing fields by name '''
        # init attributes to default value
        self.header_ = std_msgs/msg/Header_.std_msgs.msg.dds_.Header_()
        self.axes_ = []
        self.buttons_ = []
        # set values for attributes passed in
        for key, value in kwargs.items():
            if key not in self._member_attributes:
                raise TypeError('Invalid argument name : %s' %(key))
            setattr(self, key, value)

    _packing_fmt = None

    @staticmethod
    def _get_packing_fmt():
        ''' Returns packing format of this class data '''
        if Joy_._packing_fmt is not None:
            return Joy_._packing_fmt
        fmt = ''
        fmt += ddsutil._align(fmt, std_msgs/msg/Header_.std_msgs.msg.dds_.Header_._get_packing_fmt())
        fmt += ddsutil._align(fmt, ddsutil._pad_fmt('iiP?'))
        fmt += ddsutil._align(fmt, ddsutil._pad_fmt('iiP?'))

        Joy_._packing_fmt = ddsutil._pad_fmt(fmt)
        return Joy_._packing_fmt

    def _serialize(self):
        ''' Serialize data for writing '''
        fmt = self._get_packing_fmt()
        args = self._get_packing_args()
        result = struct.pack(fmt, *args)
        return result

    def _deserialize(self, data):
        ''' Initialize values from data returned by struct.unpack()'''
        self.header_ = std_msgs/msg/Header_.std_msgs.msg.dds_.Header_()._deserialize(data)
        self.axes_ = ddsutil._deserialize_seq(data, 'f', lambda seq_data: seq_data.pop(0))
        self.buttons_ = ddsutil._deserialize_seq(data, 'i', lambda seq_data: seq_data.pop(0))
        return self;

    def _get_packing_args(self):
        ''' Return an list of data suitable for struct.pack '''
        args = []
        args.extend(self.header_._get_packing_args())
        args.extend(ddsutil._serialize_seq(self.axes_, 'f', lambda seq_args, v: seq_args.append(v)))
        args.extend(ddsutil._serialize_seq(self.buttons_, 'i', lambda seq_args, v: seq_args.append(v)))
        return args

